Subject: Re: [Patch net v6 4/8] net_sched: Implement the right netem duplication behavior

From: Jakub Kicinski <[email-masked]>
Date: Wed, 7 Jan 2026 18:18:33 -0800

On Wed, 7 Jan 2026 15:33:53 -0800 Cong Wang wrote:
> > It is worth testing for the case where netem is used as a leaf qdisc.
> > I worry that this could cause the parent qdisc to get accounting wrong.
> > I.e if HTB calls netem and netem queues 2 packets, the qlen in HTB
> > would be incorrect.  
> 
> In patch 6/8, I added "Test PRIO with NETEM duplication", which installs
> netem Qdisc as a child and leaf of root prio qdisc.
> 
> Or am I misunderstanding it?

Does something automatically validates that backlog is 0 when qdisc is
destroyed? The test itself only checks:

  "matchPattern": "Sent \\d+ bytes (\\d+) pkt",